program day
    implicit none
    integer, parameter :: max_chars = 300
    integer, parameter :: max_rows = 300
    integer, parameter :: max_loop_size = 100000
    character(200) :: fname
    character(max_chars) :: fline
    character(len=1) :: cell
    integer :: n_arguments
    integer :: istat
    character(max_chars) :: map(1:max_rows)
    character(len=1) :: s_char
    !integer :: loop_y(1:max_loop_size), loop_x(1:max_loop_size)
    integer :: Sy, Sx
    integer :: pos_y, pos_x
    integer :: mov_y, mov_x, myb, mxb
    integer :: n_rows, n_cols
    integer :: i, temp
    logical :: found_end, found_Sdr
    integer :: inside, t_inside

    n_arguments = command_argument_count()
    if (n_arguments .eq. 1) then
        call get_command_argument(1, fname)
        print *, "File: ", trim(fname)
        print *
    else
        print *, "Wrong number of arguments: ", n_arguments
        stop
    end if

    n_rows = 0
    open(10, file=fname)
    do i=1,max_rows
        read(10, "(a)", iostat=istat) fline
        if ((len_trim(fline) .eq. 0) .or. (is_iostat_end(istat))) then
            exit
        end if
        temp = scan(fline, "S")
        if (temp .ne. 0) then
            Sx = temp
            Sy = i
        end if
        map(i) = fline
        n_rows = n_rows + 1
    end do
    close(10)
    n_cols = len_trim(map(1))
    print *, "Map rows:    ", n_rows
    print *, "Map columns: ", n_cols
    print *, "Starting row:    ", Sy
    print *, "Starting column: ", Sx

    found_Sdr = .false.
    if (Sy .gt. 1) then
        cell = map(Sy-1)(Sx:Sx)
        temp = scan(cell, "|7F")
        if (temp .ne. 0) then
            if (found_Sdr) then
                myb = mov_y
                mxb = mov_x
            end if
            found_Sdr = .true.
            mov_y = -1
            mov_x = 0
        end if
    end if
    if (Sy .lt. n_rows) then
        cell = map(Sy+1)(Sx:Sx)
        temp = scan(cell, "|LJ")
        if (temp .ne. 0) then
            if (found_Sdr) then
                myb = mov_y
                mxb = mov_x
            end if
            found_Sdr = .true.
            mov_y = 1
            mov_x = 0
        end if
    end if
    if (Sx .gt. 1) then
        cell = map(Sy)((Sx-1):(Sx-1))
        temp = scan(cell, "-LF")
        if (temp .ne. 0) then
            if (found_Sdr) then
                myb = mov_y
                mxb = mov_x
            end if
            found_Sdr = .true.
            mov_y = 0
            mov_x = -1
        end if
    end if
    if (Sx .lt. n_cols) then
        cell = map(Sy)((Sx+1):(Sx+1))
        temp = scan(cell, "-J7")
        if (temp .ne. 0) then
            if (found_Sdr) then
                myb = mov_y
                mxb = mov_x
            end if
            found_Sdr = .true.
            mov_y = 0
            mov_x = 1
        end if
    end if
    print *, "Starting row dir: ", mov_y
    print *, "Starting col dir: ", mov_x
    print *, "Other row dir: ", myb
    print *, "Other col dir: ", mxb
    s_char = 'f'
    pos_y = Sy
    pos_x = Sx
    found_end = .false.
    do i = 1, max_loop_size
        pos_y = pos_y + mov_y
        pos_x = pos_x + mov_x
        if (pos_y .lt. 1 .or. pos_y .gt. n_rows) then
            print *, "Bad Y position: ", pos_y
            print *, "X: ", pos_x
            print *, "i: ", i
            stop
        else if (pos_x .lt. 1 .or. pos_x .gt. n_cols) then
            print *, "Y: ", pos_y
            print *, "Bad X position: ", pos_x
            print *, "i: ", i
            stop
        end if
        cell = map(pos_y)(pos_x:pos_x)
        !print *, cell, pos_y, pos_x
        if (cell .eq. 'S') then
            found_end = .true.
            map(pos_y)(pos_x:pos_x) = s_char
            exit
        else if (cell .eq. '7') then
            if (mov_x .eq. 1) then
                mov_x = 0
                mov_y = 1
            else if (mov_y .eq. -1) then
                mov_y = 0
                mov_x = -1
            else
                print *, "Error at ", cell, pos_y, pos_x
            end if
            map(pos_y)(pos_x:pos_x) = '&'
        else if (cell .eq. 'J') then
            if (mov_x .eq. 1) then
                mov_x = 0
                mov_y = -1
            else if (mov_y .eq. 1) then
                mov_y = 0
                mov_x = -1
            else
                print *, "Error at ", cell, pos_y, pos_x
            end if
            map(pos_y)(pos_x:pos_x) = 'j'
        else if (cell .eq. 'F') then
            if (mov_x .eq. -1) then
                mov_x = 0
                mov_y = 1
            else if (mov_y .eq. -1) then
                mov_y = 0
                mov_x = 1
            else
                print *, "Error at ", cell, pos_y, pos_x
            end if
            map(pos_y)(pos_x:pos_x) = 'f'
        else if (cell .eq. 'L') then
            if (mov_x .eq. -1) then
                mov_x = 0
                mov_y = -1
            else if (mov_y .eq. 1) then
                mov_y = 0
                mov_x = 1
            else
                print *, "Error at ", cell, pos_y, pos_x
            end if
            map(pos_y)(pos_x:pos_x) = 'l'
        else if (cell .eq. '-') then
            map(pos_y)(pos_x:pos_x) = '_'
        else if (cell .eq. '|') then
            map(pos_y)(pos_x:pos_x) = 'I'
        else
            print *, "Bad cell: ", cell, pos_y, pos_x
        end if
    end do
    if (found_end) then
        print *, "Found end after ", i, " iterations"
        print *, "Furthest distance: ", i/2
    else
        print *, "Did not find end after ", max_loop_size, " iterations"
    end if
    inside = 0
    do i = 1,n_rows
        t_inside = num_inside_row(map(i))
        inside = inside + t_inside
    end do
    print *, "Spaces inside: ", inside

    contains
        function num_inside_row(row) result(num)
            character(*), intent(in) :: row
            integer :: num
            integer :: i, rlen, cur
            integer :: edge_info(1:3)
            integer :: incr, n_mov 
            num = 0
            rlen = len_trim(row) 
            cur = 1
            incr = 0
            do i=1, rlen
                if (cur .ge. rlen) then
                    exit
                end if
                edge_info = next_edge(row(cur:rlen))
                !print *, edge_info
                if (edge_info(1) .eq. 0) then
                    return
                else if (edge_info(2) .lt. edge_info(1)) then
                    print *, "???"
                    return
                end if
                if (incr .eq. 1) then
                    n_mov = edge_info(1) - 1
                    num = num + n_mov
                    if (edge_info(3) .eq. 1) then
                        incr = 0
                    end if
                else
                    if (edge_info(3) .eq. 1) then
                        incr = 1
                    end if
                end if
                cur = cur + edge_info(2)
                !print *, "cur: ", cur
            end do
        end function num_inside_row

        function next_edge(str)
            character(*), intent(in) :: str
            integer :: next_edge(1:3)
            integer :: estart, eend
            character(len=1) :: c1, c2
            integer :: rlen
            estart = scan(str, "Ifl")
            if (estart .eq. 0) then
                ! No more edges
                next_edge = 0
                return
            end if
            c1 = str(estart:estart)
            next_edge(1) = estart
            if (c1 .eq. 'I') then
                next_edge(2) = estart
                next_edge(3) = 1
                return
            end if
            rlen = len_trim(str)
            eend = scan(str(estart:rlen), "&j") + estart - 1
            next_edge(2) = eend
            c2 = str(eend:eend)
            if ((c1 .eq. 'f') .and. (c2 .eq. '&')) then
                next_edge(3) = 0
            else if ((c1 .eq. 'l') .and. (c2 .eq. 'j')) then
                next_edge(3) = 0
            else
                next_edge(3) = 1
            end if
        end function next_edge

end program day

